/*
 * main.h - main header file
 *
 * author: hackbard@hackdaworld.dyndns.org
 *
 */

#ifndef MAIN_H
#define MAIN_H

#define _GNU_SOURCE
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <pcap.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/time.h>

#include <linux/wireless.h>

#include "parse.h"

#define SYSCALL_MAX 32
#define CHANNEL_MAX 13
#define MAX_DEV_CHARS 6
#define MAX_SYSCALL_CHARS 64

#define HOP_SEC 0
#define HOP_USEC 200000

/* modes */
#define MODE_MONITOR (1<<0)
#define MODE_WLANNG (1<<1)
#define MODE_QUIT (1<<2)
#define MODE_HEXOUT (1<<3)
#define MODE_ASCIIOUT (1<<4)

#define MAX_BYTE_WEP 13 /* maximal 104 bit key */

/* type definitions */
typedef struct s_info {
  int count; /* count packages */
  unsigned char mode; /* monitoring/managed mode */
  char device[MAX_DEV_CHARS]; /* sniffed devie */
  int logfile_fd; /* file descriptof for logfile */
  int pcap_fd; /* fd for reading pcap events */
  int current_channel;
  int channel_hop_fd;
  char key[13]; /* wep key */
  pcap_t *pcap_handle;
} t_info;


/* function prototypes */
int usage(void); 
int get_user_event(t_info *info);
int hop_channel(t_info *info);

#endif
